#define _CRT_SECURE_NO_DEPRECATE
#include "Header.h"

#define CLEAR(x) while(!x.empty()) x.pop()

int moves[][4]={
	{0, -1},
	{0, +1},
	{-1, 0},
	{+1, 0}
};

//#define INPUTFILENAME ("tests\\game.01.in")
//#define OUTPUTFILENAME ("output\\game.01.out")
#define INPUTFILENAME "game.in"
#define OUTPUTFILENAME "game.out"
#define DIM 32
#define FREE -1000
#define INTPAIR pair<int,int>
#define COLORED -2
#define MOVED1 -4
#define MOVED2 -3

stack<INTPAIR > lastMoves;
stack<INTPAIR > lastMoves1;

bool possibleFirst(int, int);
bool possibleNext(int, int);

int resultrow, resultcol;
int n;
int a[DIM][DIM];
int acpy[DIM][DIM];
int acpy2[DIM][DIM];
int result = 0;

int strToInt(string&);
void readInput();
void solve();

bool canMoveAt(int i, int j);
bool cantMove();

void undoMove(stack<INTPAIR >&);
int rrw, rrc;

void makemove1q(int, int);
void makemove1st(int, int);
void makemove2q(int, int);
void makemove2st(int, int);

inline void normalizeField();

void print();

int main()
{
	double stm = clock();
	freopen(INPUTFILENAME, "r" , stdin);
	freopen(OUTPUTFILENAME , "w", stdout);
	memset(a, -1, sizeof(a));
	memset(acpy, -1, sizeof(acpy));
	memset(acpy2, -1, sizeof(acpy2));
	readInput();
	solve();
	print();
//	fprintf(stdout, "\nTIME : %lf\n", (clock() - stm) / CLOCKS_PER_SEC);
	return 0;
}

void print()
{
	cout << a[rrw][rrc] << endl;
	cout<<rrw<<' '<<rrc<<endl;
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < n; ++j)
		{
			if(a[i][j] == MOVED1)
			{
				cout << i << ' ' << j << endl;
			}
		}
}

void normalizeacpy2()
{
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			acpy2[i][j] = a[i][j];
		}
	}
}

bool canMoveAt(int i, int j)
{
	if (!possibleFirst(i, j))
	{
		return false;
	}
	queue<INTPAIR > q;
	q.push(INTPAIR(i, j));
	int s = 1;
	if (s == a[i][j])
	{
		return true;
	}
	while (!q.empty())
	{
		INTPAIR t = q.front();
		q.pop();
		for (int l = 0; l < 4; l++)
		{
			int x = t.first + moves[l][0];
			int y = t.second + moves[l][1];
			if (possibleNext(x, y))
			{
				q.push(INTPAIR(x, y));
				acpy2[x][y] = MOVED1;
				s++;
				if (s == a[i][j])
				{
					normalizeacpy2();
					return true;
				}
			}

		}
	}
	normalizeacpy2();
	return false;
}

void transform()
{
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (acpy[i][j] == MOVED2 && a[i][j] < 0)
			{
				acpy[i][j] = MOVED1;
				a[i][j] = MOVED1;
			}
			acpy2[i][j] = a[i][j];
		}
	}
}

void solve()
{
	//looking for win moves
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (canMoveAt(i, j))
			{
				makemove1q(i, j);
				transform();
				if (cantMove())
				{
					rrw = i, rrc = j;
					return;
				}
				undoMove(lastMoves);
				normalizeField();

				makemove1st(i, j);
				transform();
				if (cantMove())
				{
					rrw = i, rrc = j;
					return;
				}
				undoMove(lastMoves);
				normalizeField();

			}
		}
	}
	
	//looking for lose moves and skip them
	//for first not lose - do it
	bool flag = false;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (canMoveAt(i, j))
			{
				makemove1q(i, j);
				transform();
				for (int ii = 0; ii < n; ii++)
				{
					for (int jj = 0; jj < n; jj++)
					{
						if (ii == i && jj == j)
						{
							continue;
						}
						if (canMoveAt(ii, jj))
						{
							makemove2q(ii, jj);
							transform();

							if (cantMove())
							{
								undoMove(lastMoves1);
								flag = true;
								continue;
							}
							undoMove(lastMoves1);
							normalizeField();
							if (flag)
							{
								break;
							}

							makemove2st(ii, jj);
							transform();

							if (cantMove())
							{
								undoMove(lastMoves1);
								flag = true;
								continue;
							}
						
							undoMove(lastMoves1);
							normalizeField();

							if (flag)
							{
								break;
							}

						}
					}
				}
				if (!flag)
				{
					rrc = j;
					rrw = i;
					return;
				}

				undoMove(lastMoves);
			}
		}
	}
	
	//looking for first avaiable if there aren't not-lost moves
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (canMoveAt(i, j))
			{
				rrw = i, rrc = j;
				makemove1q(i, j);
				transform();
				return;
			}
		}
	}
}

int strToInt(string &s)
{
	int res;
	stringstream ss;
	ss<<s;
	ss>>res;
	return res;
}

void readInput()
{
	cin>>n;
	cin.get();
	string word;
	for(int i = 0; i < n; ++i)
	{
		for(int j=0; j<n; ++j)
		{
			cin>>word;
			if(word != " " && word != "")
				if(word == "#") 
					a[i][j] = FREE , acpy[i][j] = FREE, acpy2[i][j] = FREE;
				else if(word == "B")
				{
					a[i][j] = COLORED;
					acpy[i][j] = COLORED;
					acpy2[i][j] = COLORED;
				}
				else
				{
					int zzz = strToInt(word);
					a[i][j] = zzz, acpy[i][j] = zzz, acpy2[i][j] = zzz;
				}
		}
	}
}

inline void normalizeField()
{
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			acpy[i][j] = a[i][j];
		}
	}
}

bool possibleFirst(int i, int j)
{
	if (i < 0 || i >= n || j < 0 || j >= n)
	{
		return false;
	}
	if (a[i][j] < 1) return false;
	for (int l = 0; l < 4; l++)
	{
		int x = i + moves[l][0];
		int y = j + moves[l][1];
		if (acpy[x][y] == MOVED1 || acpy[x][y] == MOVED2 || acpy[x][y] == COLORED)
			return false;
	}
	return true;
}

bool possibleNext(int i, int j)
{
	if (acpy2[i][j] == MOVED1) return false;
	if (i < 0 || i >= n || j < 0 || j >= n)
	{
		return false;
	}
	if (a[i][j] != FREE) return false;
	for (int l = 0; l < 4; l++)
	{
		int x = i + moves[l][0];
		int y = j + moves[l][1];
		if (acpy[x][y] == COLORED || acpy[x][y] == MOVED1)
			return false;
	}
	return true;
}

void makemove1q(int i, int j)
{
	queue<INTPAIR > q;
	q.push(INTPAIR(i, j));
	acpy[i][j] = MOVED2;
	int s = 1;
	if (s == a[i][j])
	{
		return;
	}
	while (!q.empty())
	{
		INTPAIR t = q.front();
		q.pop();
		for (int l = 0; l < 4; l++)
		{
			int x = t.first + moves[l][0];
			int y = t.second + moves[l][1];
			if (possibleNext(x, y))
			{
				q.push(INTPAIR(x, y));
				lastMoves.push(INTPAIR(x, y));
				acpy2[x][y] = MOVED1;
				acpy[x][y] = MOVED2;
				s++;
				if (s == a[i][j])
				{
					normalizeacpy2();
					lastMoves.push(INTPAIR(i, j));
					return;
				}
			}

		}
	}
	normalizeacpy2();
}

void makemove1st(int i, int j)
{
	stack<INTPAIR > q;
	q.push(INTPAIR(i, j));
	acpy[i][j] = MOVED2;
	int s = 1;
	if (s == a[i][j])
	{
		return;
	}
	while (!q.empty())
	{
		INTPAIR t = q.top();
		q.pop();
		for (int l = 0; l < 4; l++)
		{
			int x = t.first + moves[l][0];
			int y = t.second + moves[l][1];
			if (possibleNext(x, y))
			{
				q.push(INTPAIR(x, y));
				lastMoves.push(INTPAIR(x, y));
				acpy2[x][y] = MOVED1;
				acpy[x][y] = MOVED2;
				s++;
				if (s == a[i][j])
				{
					normalizeacpy2();
					lastMoves.push(INTPAIR(i, j));
					return;
				}
			}

		}
	}
	normalizeacpy2();
}

void undoMove(stack<INTPAIR >& st)
{
	if (st.empty()) return;
	INTPAIR tp = st.top();
	st.pop();
	acpy[tp.first][tp.second] = a[tp.first][tp.second];
	while (!st.empty())
	{
		tp = st.top();
		st.pop();
		acpy[tp.first][tp.second] = a[tp.first][tp.second] = FREE;
	}
}

bool cantMove()
{
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (canMoveAt(i, j))
			{
				return false;
			}
		}
	}
	return true;
}

void makemove2q(int i, int j)
{
	queue<INTPAIR > q;
	q.push(INTPAIR(i, j));
	acpy[i][j] = MOVED2;
	int s = 1;
	if (s == a[i][j])
	{
		return;
	}
	while (!q.empty())
	{
		INTPAIR t = q.front();
		q.pop();
		for (int l = 0; l < 4; l++)
		{
			int x = t.first + moves[l][0];
			int y = t.second + moves[l][1];
			if (possibleNext(x, y))
			{
				q.push(INTPAIR(x, y));
				lastMoves1.push(INTPAIR(x, y));
				acpy2[x][y] = MOVED1;
				acpy[x][y] = MOVED2;
				s++;
				if (s == a[i][j])
				{
					normalizeacpy2();
					lastMoves1.push(INTPAIR(i, j));
					return;
				}
			}

		}
	}
	normalizeacpy2();
}

void makemove2st(int i, int j)
{
	stack<INTPAIR > q;
	q.push(INTPAIR(i, j));
	acpy[i][j] = MOVED2;
	int s = 1;
	if (s == a[i][j])
	{
		return;
	}
	while (!q.empty())
	{
		INTPAIR t = q.top();
		q.pop();
		for (int l = 0; l < 4; l++)
		{
			int x = t.first + moves[l][0];
			int y = t.second + moves[l][1];
			if (possibleNext(x, y))
			{
				q.push(INTPAIR(x, y));
				lastMoves1.push(INTPAIR(x, y));
				acpy2[x][y] = MOVED1;
				acpy[x][y] = MOVED2;
				s++;
				if (s == a[i][j])
				{
					normalizeacpy2();
					lastMoves1.push(INTPAIR(i, j));
					return;
				}
			}

		}
	}
	normalizeacpy2();
}